/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util;

import com.jiuqi.util.StringUtils;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class StringList
implements Serializable,
Cloneable {
    private static final int DELIMITER_DEFINED = 1;
    private static final int QUOTECHAR_DEFINED = 2;
    private static final int NAMEVALSEP_DEFINED = 4;
    protected List items = new ArrayList();
    protected List objects = null;
    private char delimiter = '\u0000';
    private char quoteChar = '\u0000';
    private char nameValueSeparator = '\u0000';
    private int defined = 0;
    private static final String CS_GB2312 = "GB2312";
    private static final String CS_ISO_8859_1 = "ISO-8859-1";

    protected boolean getDefined(int item) {
        return (this.defined & item) != 0;
    }

    protected void setDefined(int item) {
        this.defined |= item;
    }

    public boolean isEmpty() {
        return this.items.size() == 0;
    }

    public int size() {
        return this.items.size();
    }

    public void clear() {
        this.items.clear();
        if (this.objects != null) {
            this.objects.clear();
        }
    }

    public String get(int index) {
        return (String)this.items.get(index);
    }

    public void set(int index, String newValue) {
        this.items.set(index, newValue);
    }

    public Object getObject(int index) {
        return this.objects == null ? null : this.objects.get(index);
    }

    public Object getObject(String item) {
        if (this.objects == null) {
            return null;
        }
        int index = this.indexOf(item);
        return index < 0 ? null : this.objects.get(index);
    }

    public void setObject(int index, Object value) {
        if (value == null && this.objects == null) {
            return;
        }
        if (this.objects == null) {
            this.objects = new ArrayList(this.size());
            int i = 0;
            while (i < this.size()) {
                this.objects.add(null);
                ++i;
            }
        }
        this.objects.set(index, value);
    }

    public void setObject(String item, Object value) {
        int index = this.indexOf(item);
        if (index < 0) {
            this.add(item);
            index = this.size() - 1;
        }
        this.setObject(index, value);
    }

    public void assign(StringList source) {
        if (source.items == null) {
            if (this.items != null) {
                this.items.clear();
            }
        } else {
            if (this.items == null) {
                this.items = new ArrayList();
            } else {
                this.items.clear();
            }
            this.items.addAll(source.items);
        }
        if (source.objects == null) {
            if (this.objects != null) {
                this.objects.clear();
            }
        } else {
            if (this.objects == null) {
                this.objects = new ArrayList();
            } else {
                this.objects.clear();
            }
            this.objects.addAll(source.objects);
        }
    }

    public void add(String item) {
        this.items.add(item);
        if (this.objects != null) {
            this.objects.add(null);
        }
    }

    public void add(String item, Object data) {
        this.items.add(item);
        if (this.objects != null) {
            this.objects.add(null);
        }
        this.setObject(this.items.size() - 1, data);
    }

    public void add(int index, String item) {
        this.items.add(index, item);
        if (this.objects != null) {
            this.objects.add(index, null);
        }
    }

    public void remove(int index) {
        this.items.remove(index);
        if (this.objects != null) {
            this.objects.remove(index);
        }
    }

    public void remove(String item) {
        int i = this.items.size() - 1;
        while (i >= 0) {
            String str = (String)this.items.get(i);
            if (str == item || str != null && str.equals(item)) {
                this.items.remove(i);
                if (this.objects == null) break;
                this.objects.remove(i);
                break;
            }
            --i;
        }
    }

    public int indexOf(String item) {
        return this.items.indexOf(item);
    }

    public int find(String item) {
        int sb = 0;
        int se = this.items.size() - 1;
        int flag = -1;
        while (sb <= se) {
            int sp = sb + se >> 1;
            flag = StringList.compare(item, (String)this.items.get(sp));
            if (flag > 0) {
                sb = sp + 1;
                continue;
            }
            if (flag < 0) {
                se = sp - 1;
                continue;
            }
            sb = sp;
            break;
        }
        return flag == 0 ? sb : -sb - 1;
    }

    public int addsort(String item) {
        int index = this.find(item);
        if (index < 0) {
            this.items.add(-index - 1, item);
            if (this.objects != null) {
                this.objects.add(-index - 1, null);
            }
        }
        return index;
    }

    public int indexOfObject(Object obj) {
        return this.objects == null ? -1 : this.objects.indexOf(obj);
    }

    protected void quicksort(int L, int R) {
        int I;
        do {
            I = L;
            int J = R;
            String zfn = (String)this.items.get(L + R >> 1);
            while (true) {
                if (StringList.compare(zfn, (String)this.items.get(I)) > 0) {
                    ++I;
                    continue;
                }
                while (StringList.compare(zfn, (String)this.items.get(J)) < 0) {
                    --J;
                }
                if (I <= J) {
                    Object T = this.items.get(I);
                    this.items.set(I, this.items.get(J));
                    this.items.set(J, T);
                    if (this.objects != null) {
                        T = this.objects.get(I);
                        this.objects.set(I, this.objects.get(J));
                        this.objects.set(J, T);
                    }
                    ++I;
                    --J;
                }
                if (I > J) break;
            }
            if (L < J) {
                this.quicksort(L, J);
            }
            L = I;
        } while (I < R);
    }

    public void sort() {
        if (this.items.size() > 1) {
            this.quicksort(0, this.items.size() - 1);
        }
    }

    public String getText() {
        StringBuffer text = new StringBuffer(1024);
        int i = 0;
        while (i < this.items.size()) {
            text.append(this.get(i));
            text.append('\n');
            ++i;
        }
        return text.toString();
    }

    public void setText(String newText) {
        StringTokenizer st = new StringTokenizer(newText, "\n");
        this.items.clear();
        while (st.hasMoreTokens()) {
            String s = st.nextToken();
            if (s != null && s.length() > 0 && s.charAt(s.length() - 1) == '\r') {
                s = s.substring(0, s.length() - 1);
            }
            this.items.add(s);
        }
        this.objects = null;
    }

    public String[] toStringArray() {
        if (this.size() == 0) {
            return null;
        }
        String[] result = new String[this.size()];
        int i = 0;
        while (i < this.size()) {
            result[i] = this.get(i);
            ++i;
        }
        return result;
    }

    public Object[] toObjectArray() {
        if (this.size() == 0) {
            return null;
        }
        Object[] result = new Object[this.size()];
        int i = 0;
        while (i < this.size()) {
            result[i] = this.getObject(i);
            ++i;
        }
        return result;
    }

    public String toString() {
        StringBuffer result = new StringBuffer("[");
        int i = 0;
        while (i < this.size()) {
            result.append("(\"" + this.get(i) + "\", ");
            result.append(this.getObject(i));
            result.append(")");
            if (i < this.size() - 1) {
                result.append(", ");
            }
            ++i;
        }
        result.append("]");
        return result.toString();
    }

    public Object clone() {
        StringList result = null;
        try {
            result = (StringList)super.clone();
            result.items = this.items == null ? null : (List)((ArrayList)this.items).clone();
            result.objects = this.objects == null ? null : (List)((ArrayList)this.objects).clone();
        }
        catch (CloneNotSupportedException cloneNotSupportedException) {}
        return result;
    }

    public static int compare(String s1, String s2) {
        if (s1 == null && s2 == null) {
            return 0;
        }
        if (s1 == null) {
            return -1;
        }
        if (s2 == null) {
            return 1;
        }
        try {
            String ns1 = new String(s1.toString().getBytes(CS_GB2312), CS_ISO_8859_1);
            String ns2 = new String(s2.toString().getBytes(CS_GB2312), CS_ISO_8859_1);
            return ns1.compareTo(ns2);
        }
        catch (Exception exception) {
            return 0;
        }
    }

    public char getDelimiter() {
        return this.getDefined(1) ? (char)this.delimiter : (char)';';
    }

    public void setDelimiter(char value) {
        this.delimiter = value;
        this.setDefined(1);
    }

    public char getQuoteChar() {
        return this.getDefined(2) ? (char)this.quoteChar : (char)'\"';
    }

    public void setQuoteChar(char value) {
        this.quoteChar = value;
        this.setDefined(2);
    }

    public char getNameValueSeparator() {
        return this.getDefined(4) ? (char)this.nameValueSeparator : (char)'=';
    }

    public void setNameValueSeparator(char value) {
        this.nameValueSeparator = value;
        this.setDefined(4);
    }

    public String getDelimitedText() {
        StringBuffer retText = new StringBuffer();
        int count = this.size();
        if (count == 1 && StringUtils.isEmpty(this.get(0))) {
            retText.append(this.getQuoteChar());
            retText.append(this.getQuoteChar());
        } else {
            int i = 0;
            while (i < count) {
                String s = this.get(i);
                if (s.indexOf(this.getQuoteChar()) != -1 || s.indexOf(this.getDelimiter()) != -1) {
                    s = StringUtils.quote(s, this.getQuoteChar());
                }
                if (i > 0) {
                    retText.append(this.getDelimiter());
                }
                retText.append(s);
                ++i;
            }
        }
        return retText.toString();
    }

    public void setDelimitedText(String value) {
        this.clear();
        if (StringUtils.isEmpty(value)) {
            return;
        }
        StringBuffer buffer = new StringBuffer();
        boolean startQuote = false;
        int i = 0;
        while (i < value.length()) {
            char curChar;
            if ((curChar = value.charAt(i++)) == this.getQuoteChar()) {
                if (startQuote) {
                    if (i >= value.length()) break;
                    if (value.charAt(i) == this.getQuoteChar()) {
                        buffer.append(value.charAt(i));
                        ++i;
                        continue;
                    }
                    if (value.charAt(i) == this.getDelimiter()) {
                        startQuote = false;
                        continue;
                    }
                    buffer.append(value.charAt(i));
                    ++i;
                    continue;
                }
                if (buffer.length() > 0) {
                    buffer.append(curChar);
                    continue;
                }
                startQuote = true;
                continue;
            }
            if (curChar == this.getDelimiter()) {
                if (startQuote) {
                    buffer.append(curChar);
                    continue;
                }
                this.add(buffer.toString());
                buffer = new StringBuffer();
                startQuote = false;
                continue;
            }
            buffer.append(curChar);
        }
        this.add(buffer.toString());
    }

    protected String extractName(String s) {
        if (s == null) {
            return null;
        }
        int index = s.indexOf(this.getNameValueSeparator());
        if (index == -1) {
            return null;
        }
        return s.substring(0, index);
    }

    public String getName(int index) {
        return this.extractName(this.get(index));
    }

    public int indexOfName(String name) {
        if (name == null) {
            return -1;
        }
        int i = 0;
        while (i < this.size()) {
            if (StringList.compare(name, this.getName(i)) == 0) {
                return i;
            }
            ++i;
        }
        return -1;
    }

    public String getValue(String name) {
        int index = this.indexOfName(name);
        if (index == -1) {
            return null;
        }
        return this.get(index).substring(name.length() + 1);
    }

    public void setValue(String name, String value) {
        int index = this.indexOfName(name);
        if (StringUtils.isEmpty(value)) {
            if (index != -1) {
                this.remove(index);
            }
        } else if (index == -1) {
            this.add(String.valueOf(name) + this.getNameValueSeparator() + value);
        } else {
            this.set(index, String.valueOf(name) + this.getNameValueSeparator() + value);
        }
    }

    public String getValue(int index) {
        String name = this.getName(index);
        if (StringUtils.isEmpty(name)) {
            return this.get(index);
        }
        return this.get(index).substring(name.length() + 1);
    }

    public void setValue(int index, String value) {
        if (StringUtils.isEmpty(value)) {
            if (index >= 0) {
                this.remove(index);
            }
        } else if (index >= 0) {
            this.set(index, String.valueOf(this.getName(index)) + this.getNameValueSeparator() + value);
        } else {
            this.add(String.valueOf(this.getNameValueSeparator()) + value);
        }
    }
}

